com.io7m.jstructural.core

## Class SSection

- java.lang.Object
- - com.io7m.jstructural.core.SSection

- Direct Known Subclasses:
    SSectionWithParagraphs, SSectionWithSubsections

      @Immutable
      public abstract class SSection
      extends Object

  An abstract section.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SSection(com.io7m.jaux.functional.Option<String> in_type, com.io7m.jaux.functional.Option<SID> in_id, SSectionTitle in_title, com.io7m.jaux.functional.Option<SSectionContents> in_contents)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `com.io7m.jaux.functional.Option<SSectionContents>` | `getContents()`
    `com.io7m.jaux.functional.Option<SID>` | `getID()`
    `SSectionTitle` | `getTitle()`
    `com.io7m.jaux.functional.Option<String>` | `getType()`
    `int` | `hashCode()`
    `abstract <S> S` | `sectionAccept(SSectionVisitor<S> v)` Accept a section visitor.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SSection

          protected SSection(@Nonnull
                  com.io7m.jaux.functional.Option<String> in_type,
                  @Nonnull
                  com.io7m.jaux.functional.Option<SID> in_id,
                  @Nonnull
                  SSectionTitle in_title,
                  @Nonnull
                  com.io7m.jaux.functional.Option<SSectionContents> in_contents)
                      throws com.io7m.jaux.Constraints.ConstraintError

      Throws:
        `com.io7m.jaux.Constraints.ConstraintError`

  - ### Method Detail

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getContents

          @Nonnull
          public final com.io7m.jaux.functional.Option<SSectionContents> getContents()

      Returns:
        The section contents

    - #### getID

          @Nonnull
          public final com.io7m.jaux.functional.Option<SID> getID()

      Returns:
        The section ID

    - #### getTitle

          @Nonnull
          public final SSectionTitle getTitle()

      Returns:
        The section title

    - #### getType

          @Nonnull
          public final com.io7m.jaux.functional.Option<String> getType()

      Returns:
        The section type attribute

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### sectionAccept

          public abstract <S> S sectionAccept(@Nonnull
                            SSectionVisitor<S> v)
                                   throws com.io7m.jaux.Constraints.ConstraintError,
                                          Exception

      Accept a section visitor.
      Type Parameters:
        `S` - The type of transformed `SSection`s
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises `Constraints.ConstraintError`
        `Exception` - If the visitor raises an `Exception`

Copyright © 2014. All rights reserved.